# This file was created automatically, do not edit!
#############################################################################
##
#W  docxpl2.tst            GAP 4 package SingerAlg              Thomas Breuer
##
#Y  Copyright (C)  2021,   Lehrstuhl D für Mathematik,  RWTH Aachen,  Germany
##
##  This file contains the GAP code of those examples in the package
##  documentation files that do not involve the visual mode used by the
##  Browse package.
##  
##  In order to run the tests, one starts GAP from the 'tst' subdirectory
##  of the 'pkg/singeralg' directory, and calls 'Test( "docxpl2.tst" );'.
##  

gap> LoadPackage( "SingerAlg", false );
true
gap> save:= SizeScreen();;
gap> SizeScreen( [ 72 ] );;
gap> START_TEST( "docxpl2.tst" );

##  doc/tutorial.xml (25-28)
gap> origpref:= UserPreference( "SingerAlg", "DisplayFunction" );;
gap> SetUserPreference( "SingerAlg", "DisplayFunction", "Print" );

##  doc/tutorial.xml (112-125)
gap> cand:= AllSingerAlgebraInfos( "e", e -> e > 2^64 );;   
gap> Length( cand );                                     
543989
gap> cand:= AllSingerAlgebraInfos( "e", e -> e > 10^10000 );;         
gap> Length( cand );
12
gap> SortParallel( List( cand, r -> r.e ), cand );
gap> cand[ Length( cand ) ];
rec( LL := 3, d := [ 1, 9438 ], dec := 0, diff := 0, 
  e := <integer 646...617 (12666 digits)>, isom := [ 9439, 2 ], 
  m := 99099, n := 9438, q := 22, vprime := [ 1, 9438, 1 ], z := 9439 
 )

##  doc/tutorial.xml (146-157)
gap> q:= 22;;  n:= 9438;;  z:= 9439;;
gap> e:= (q^n-1)/z;;
gap> coeffs1:= CoefficientsQadic( e, q );;
gap> coeffs2:= CoefficientsQadicReversed( 1, z, q, n );;
gap> Length( coeffs1 );
9436
gap> Length( coeffs2 );
9438
gap> coeffs1 = Reversed( coeffs2 ){[1..9436]};  
true

##  doc/tutorial.xml (234-252)
gap> DisplaySingerMonomials( 3, 4, 5 );
A[3,4,16]

0 | 1 |  0
1 | 6 |  1  2  3  6  9 11
2 | 7 |  4  5  7  8 12 13 15
3 | 2 | 10 14
4 | 1 | 16
gap> DisplaySingerMonomials( 3, 4, 5 : m );
A[3,4,16]

0 | 1 | (0,0,0,0)
1 | 6 | (0,0,2,1) (0,1,0,1) (0,2,1,0) (1,0,0,2) (1,0,1,0) (2,1,0,0)
2 | 7 | (0,1,2,2) (0,2,0,2) (1,1,1,1) (1,2,2,0) (2,0,1,2) (2,0,2,0)
  |   | (2,2,0,1)
3 | 2 | (1,2,1,2) (2,1,2,1)
4 | 1 | (2,2,2,2)

##  doc/tutorial.xml (258-279)
gap> DisplaySingerMonomials( 13, 2, 8 );
A[13,2,21]

0 | 1 |  0
1 | 4 |  1  2  5 13
2 | 5 |  3  4  7 10 18
3 | 4 |  6  9 12 15
4 | 5 |  8 11 14 17 20
5 | 2 | 16 19
6 | 1 | 21
gap> DisplaySingerMonomials( 13, 2, 8 : m );
A[13,2,21]

0 | 1 | ( 0, 0)
1 | 4 | ( 0, 8) ( 1, 3) ( 3, 1) ( 8, 0)
2 | 5 | ( 1,11) ( 2, 6) ( 4, 4) ( 6, 2) (11, 1)
3 | 4 | ( 3, 9) ( 5, 7) ( 7, 5) ( 9, 3)
4 | 5 | ( 4,12) ( 6,10) ( 8, 8) (10, 6) (12, 4)
5 | 2 | ( 9,11) (11, 9)
6 | 1 | (12,12)

##  doc/tutorial.xml (285-302)
gap> DisplaySingerMonomials( 5, 4, 78 );
A[5,4,8]

0 | 1 | 0
1 | 3 | 1 2 5
2 | 3 | 3 4 7
3 | 1 | 6
4 | 1 | 8
gap> DisplaySingerMonomials( 5, 4, 78 : m );
A[5,4,8]

0 | 1 | (0,0,0,0)
1 | 3 | (0,3,0,3) (1,1,1,1) (3,0,3,0)
2 | 3 | (1,4,1,4) (2,2,2,2) (4,1,4,1)
3 | 1 | (3,3,3,3)
4 | 1 | (4,4,4,4)

##  doc/tutorial.xml (308-337)
gap> DisplaySingerMonomials( 11, 2, 4 );
A[11,2,30]

 0 | 1 |  0
 1 | 3 |  1  3 11
 2 | 5 |  2  4  6 14 22
 3 | 5 |  5  7  9 17 25
 4 | 5 |  8 10 12 20 28
 5 | 3 | 13 15 23
 6 | 3 | 16 18 26
 7 | 3 | 19 21 29
 8 | 1 | 24
 9 | 1 | 27
10 | 1 | 30
gap> DisplaySingerMonomials( 11, 2, 4 : m );
A[11,2,30]

 0 | 1 | ( 0, 0)
 1 | 3 | ( 0, 4) ( 1, 1) ( 4, 0)
 2 | 5 | ( 0, 8) ( 1, 5) ( 2, 2) ( 5, 1) ( 8, 0)
 3 | 5 | ( 1, 9) ( 2, 6) ( 3, 3) ( 6, 2) ( 9, 1)
 4 | 5 | ( 2,10) ( 3, 7) ( 4, 4) ( 7, 3) (10, 2)
 5 | 3 | ( 4, 8) ( 5, 5) ( 8, 4)
 6 | 3 | ( 5, 9) ( 6, 6) ( 9, 5)
 7 | 3 | ( 6,10) ( 7, 7) (10, 6)
 8 | 1 | ( 8, 8)
 9 | 1 | ( 9, 9)
10 | 1 | (10,10)

##  doc/tutorial.xml (361-370)
gap> expls:= AllSingerAlgebraInfos( "n", 5,                                 
>                r -> r.LL = Int( r.n * ( r.q-1 ) / r.m ) + 1, false );;
gap> Length( expls );
13
gap> expls[1];
rec( LL := 7, d := [ 43, 408 ], dec := 0, diff := 1, e := 407592814, 
  isom := [ 1353, 223 ], m := 148, n := 5, q := 223, 
  vprime := [ 1, 261, 375, 395, 260, 61, 1 ], z := 1353 )

##  doc/tutorial.xml (379-383)
gap> OneSingerAlgebraInfo( "n", 4,
>        r -> r.LL = Int( r.n * ( r.q-1 ) / r.m ) + 1, false );
fail

##  doc/tutorial.xml (394-407)
gap> n:= 4;;
gap> for q in [ 2 .. 40 ] do
>      for z in DivisorsInt( q^n-1 ) do
>        if z > SingerAlg.MaxZ then
>          A:= SingerAlgebra( q, n, z );
>          m:= MinimalDegreeOfSingerAlgebra( A );
>          if LoewyLength( A ) <> Int( n * (q-1) / m ) + 1 then
>            Print( "found an example\n" );
>          fi;
>        fi;
>      od;
>    od;

##  doc/../gap/loewy.gd (585-600)
gap> A:= SingerAlgebra( 6, 2, 7 );
A[6,2,7]
gap> Dimension( A );   # is always z+1
8
gap> LeftActingDomain( A );
Rationals
gap> A2:= SingerAlgebra( 6, 2, 7, GF(2) );
A[6,2,7,GF(2)]
gap> Print( A2, "\n" );
SingerAlgebra( 6, 2, 7, GF(2) )
gap> String( A2 );
"SingerAlgebra( 6, 2, 7, GF(2) )"
gap> SingerAlgebra( rec( q:= 6, n:= 2, e:= 5 ) );
A[6,2,7]

##  doc/../gap/loewy.gd (56-66)
gap> A:= SingerAlgebra( 6, 7 );
A[6,2,7]
gap> IsSingerAlgebra( A );
true
gap> AA:= AlgebraByStructureConstants( Rationals,
>             StructureConstantsTable( Basis( A ) ) );
<algebra of dimension 8 over Rationals>
gap> IsSingerAlgebra( AA );
false

##  doc/../gap/loewy.gd (88-93)
gap> A:= SingerAlgebra( 6, 7 );
A[6,2,7]
gap> ParametersOfSingerAlgebra( A );
[ 6, 2, 7 ]

##  doc/../gap/loewy.gd (277-282)
gap> A:= SingerAlgebra( 6, 2, 7 );
A[6,2,7]
gap> DimensionsLoewyFactors( A );
[ 1, 6, 1 ]

##  doc/../gap/loewy.gd (323-332)
gap> LoewyVectorAbbreviated( [ 1, 1, 1, 1 ] );
[ [ 1, 4 ] ]
gap> LoewyVectorAbbreviated( [ 1, 7, 7, 3, 3, 1, 1, 1 ] );
[ 1, [ 7, 2 ], [ 3, 2 ], [ 1, 3 ] ]
gap> LoewyVectorExpanded( [ [ 1, 4 ] ] );
[ 1, 1, 1, 1 ]
gap> LoewyVectorExpanded( [ 1, [ 7, 2 ], [ 3, 2 ], [ 1, 3 ] ] );
[ 1, 7, 7, 3, 3, 1, 1, 1 ]

##  doc/../gap/loewy.gd (383-388)
gap> A:= SingerAlgebra( 6, 2, 7 );
A[6,2,7]
gap> LoewyLength( A );
3

##  doc/../gap/loewy.gd (502-529)
gap> expls:= [ [3,2], [2,5], [3,70], [13,70], [19,70], [5,72],
>              [2,73], [5,76], [11,80], [13,80], [2,85], [4,123],
>              [3,164], [4,369], [2,771], [15,791] ];;
gap> for l in expls do
>      q:= l[1];  z:= l[2];  n:= OrderMod( q, z );  e:= (q^n-1)/z;
>      nn:= OrderModExt( q, e, n );
>      m:= MinimalDegreeOfSingerAlgebra( q, nn, e );
>      Print( "q = ", String( q, 2 ), ", z = ", String( z, 3 ), ":  ",
>      SufficientCriterionForLoewyBoundAttained( q, n, z, m ), "\n" );
>    od;
q =  3, z =   2:  Cor. I.7.1 (n <= 3)
q =  2, z =   5:  z < 70
q =  3, z =  70:  
q = 13, z =  70:  Thm. I.7.1
q = 19, z =  70:  La. I.7.1 (iii)
q =  5, z =  72:  La. II.4.1 for r = 1
q =  2, z =  73:  Prop. II.6.1 (e <= 32)
q =  5, z =  76:  Prop. II.5.1 (ii)
q = 11, z =  80:  Prop. II.5.3, II.5.6 (e | (q^n-1)/(q-1), n <= 5)
q = 13, z =  80:  Prop. II.3.15
q =  2, z =  85:  La. I.6.3
q =  4, z = 123:  Prop. II.5.1 (iii)
q =  3, z = 164:  La. II.5.2 (ii)
q =  4, z = 369:  Prop. II.5.1 (i)
q =  2, z = 771:  La. II.4.1
q = 15, z = 791:  Thm. II.4.3 (iii)

##  doc/../gap/mindeg.gd (90-97)
gap> A:= SingerAlgebra( 6, 2, 7 );
A[6,2,7]
gap> MinimalDegreeOfSingerAlgebra( A );
5
gap> MinimalDegreeOfSingerAlgebra( 6, 5 );
5

##  doc/../gap/loewy.gd (671-679)
gap> A:= SingerAlgebra( 2, 7 );
A[2,3,7]
gap> ser:= RadicalSeriesOfAlgebra( A );
[ A[2,3,7], <algebra of dimension 7 over Rationals>, 
  <algebra of dimension 4 over Rationals>, 
  <algebra of dimension 1 over Rationals>, 
  <algebra of dimension 0 over Rationals> ]

##  doc/../gap/loewy.gd (705-713)
gap> A:= SingerAlgebra( 2, 7 );
A[2,3,7]
gap> ser:= SocleSeriesOfAlgebra( A );
[ <algebra of dimension 0 over Rationals>, 
  <algebra of dimension 1 over Rationals>, 
  <algebra of dimension 4 over Rationals>, 
  <algebra of dimension 7 over Rationals>, A[2,3,7] ]

##  doc/../gap/loewy.gd (176-182)
gap> LoewyStructureInfo( 6, 7 );
rec( LL := 3, chain := [ 8, 2, 1 ], 
  layers := [ 0, 1, 1, 1, 1, 1, 1, 2 ], m := 5, 
  monomials := [ [ 0, 0 ], [ 0, 5 ], [ 1, 4 ], [ 2, 3 ], [ 3, 2 ], 
      [ 4, 1 ], [ 5, 0 ], [ 5, 5 ] ], parameters := [ 6, 2, 7 ] )

##  doc/../gap/loewy.gd (241-248)
gap> CoefficientsQadicReversed( 2, 7, 6, 2 );
[ 1, 4 ]
gap> e:= (6^2-1)/7;
5
gap> CoefficientsQadic( 2*e, 6 );
[ 4, 1 ]

##  doc/../gap/display.g (242-282)
gap> DisplaySingerMonomials( 2, 7 );  # e = 1
A[2,3,7]

0 | 1 | 0
1 | 3 | 1 2 4
2 | 3 | 3 5 6
3 | 1 | 7
gap> DisplaySingerMonomials( 2, 7 : m );  # same, show monomials
A[2,3,7]

0 | 1 | (0,0,0)
1 | 3 | (0,0,1) (0,1,0) (1,0,0)
2 | 3 | (0,1,1) (1,0,1) (1,1,0)
3 | 1 | (1,1,1)
gap> DisplaySingerMonomials( 9, 8 : m );  # uniserial case
A[9,1,8]

0 | 1 | (0)
1 | 1 | (1)
2 | 1 | (2)
3 | 1 | (3)
4 | 1 | (4)
5 | 1 | (5)
6 | 1 | (6)
7 | 1 | (7)
8 | 1 | (8)
gap> DisplaySingerMonomials( 6, 7 : m );  # Loewy length 3
A[6,2,7]

0 | 1 | (0,0)
1 | 6 | (0,5) (1,4) (2,3) (3,2) (4,1) (5,0)
2 | 1 | (5,5)
gap> DisplaySingerMonomials( 14, 15 : m );  # wrapped output
A[14,2,15]

0 |  1 | ( 0, 0)
1 | 14 | ( 0,13) ( 1,12) ( 2,11) ( 3,10) ( 4, 9) ( 5, 8) ( 6, 7)
  |    | ( 7, 6) ( 8, 5) ( 9, 4) (10, 3) (11, 2) (12, 1) (13, 0)
2 |  1 | (13,13)

##  doc/../gap/loewy.gd (630-647)
gap> A:= SingerAlgebra( 3, 7 );
A[3,6,7]
gap> J:= RadicalOfAlgebra( A );;
gap> HasGeneratingSubsetOfCanonicalBasisOfSingerAlgebra( J );
true
gap> GeneratingSubsetOfCanonicalBasisOfSingerAlgebra( J );
[ 2 .. 8 ]
gap> P:= ProductSpace( J, J );
<vector space of dimension 1 over Rationals>
gap> HasGeneratingSubsetOfCanonicalBasisOfSingerAlgebra( P );
true
gap> GeneratingSubsetOfCanonicalBasisOfSingerAlgebra( P );
[ 8 ]
gap> V:= Subspace( A, Basis( A ){ [ 2, 3 ] } );;
gap> HasGeneratingSubsetOfCanonicalBasisOfSingerAlgebra( V );
false

##  doc/../gap/loewy.gi (1054-1065)
gap> data:= LoewyStructureInfoGAP( 2, 3, 7 );;
gap> Display( SingerAlg.MultTable( data ) );
[ [  1,  2,  3,  4,  5,  6,  7,  8 ],
  [  2,  0,  4,  0,  6,  0,  8,  0 ],
  [  3,  4,  0,  0,  7,  8,  0,  0 ],
  [  4,  0,  0,  0,  8,  0,  0,  0 ],
  [  5,  6,  7,  8,  0,  0,  0,  0 ],
  [  6,  0,  8,  0,  0,  0,  0,  0 ],
  [  7,  8,  0,  0,  0,  0,  0,  0 ],
  [  8,  0,  0,  0,  0,  0,  0,  0 ] ]

##  doc/../gap/loewy.gi (1138-1143)
gap> SingerAlg.BasisOfSum( data, [ 1, 2, 3 ], [ 2, 4, 6 ] );
[ 1, 2, 3, 4, 6 ]
gap> SingerAlg.BasisOfIntersection( data, [ 1, 2, 3 ], [ 2, 4, 6 ] );
[ 2 ]

##  doc/../gap/loewy.gi (1174-1184)
gap> data:= LoewyStructureInfoGAP( 2, 7 );;
gap> radser:= SingerAlg.BasesOfRadicalSeries( data );
[ [ 2 .. 8 ], [ 4, 6, 7, 8 ], [ 8 ] ]
gap> SingerAlg.BasisOfProductSpace( data, radser[1], radser[1] );
[ 4, 6, 7, 8 ]
gap> SingerAlg.BasisOfProductSpace( data, radser[1], radser[2] );
[ 8 ]
gap> SingerAlg.BasisOfProductSpace( data, radser[2], radser[2] );
[  ]

##  doc/../gap/loewy.gi (1227-1231)
gap> data:= LoewyStructureInfoGAP( 2, 7 );;
gap> SingerAlg.BasisOfIdeal( data, [ 4 ] );
[ 4, 8 ]

##  doc/../gap/loewy.gi (1261-1267)
gap> data:= LoewyStructureInfoGAP( 2, 7 );;
gap> radser:= SingerAlg.BasesOfRadicalSeries( data );
[ [ 2 .. 8 ], [ 4, 6, 7, 8 ], [ 8 ] ]
gap> List( radser, I -> SingerAlg.BasisOfAnnihilator( data, I ) );
[ [ 8 ], [ 4, 6, 7, 8 ], [ 2, 3, 4, 5, 6, 7, 8 ] ]

##  doc/../gap/loewy.gi (1301-1305)
gap> data:= LoewyStructureInfoGAP( 2, 7 );;
gap> radser:= SingerAlg.BasesOfRadicalSeries( data );
[ [ 2 .. 8 ], [ 4, 6, 7, 8 ], [ 8 ] ]

##  doc/../gap/loewy.gi (1346-1349)
gap> socser:= SingerAlg.BasesOfSocleSeries( data );
[ [ 8 ], [ 4, 6, 7, 8 ], [ 2 .. 8 ] ]

##  doc/../gap/loewy.gi (1392-1400)
gap> data:= LoewyStructureInfoGAP( 3, 8 );;
gap> SingerAlg.BasisOfPowers( data, [ 1 .. 9 ], 2, 1 );
[ 1, 3, 7, 9 ]
gap> SingerAlg.BasisOfPowers( data, [ 1 .. 9 ], 2, 2 );
[ 1 ]
gap> SingerAlg.BasisOfPowers( data, [ 1 .. 9 ], 3, 1 );
[ 1 ]

##  doc/../gap/loewy.gi (1448-1456)
gap> data:= LoewyStructureInfoGAP( 3, 8 );;
gap> SingerAlg.BasisOfPMRoots( data, [], 2, 1 );
[ 3, 6, 7, 8, 9 ]
gap> SingerAlg.BasisOfPMRoots( data, [], 2, 2 );
[ 2, 3, 4, 5, 6, 7, 8, 9 ]
gap> SingerAlg.BasisOfPMRoots( data, [ 3 ], 2, 1 );
[ 2, 3, 6, 7, 8, 9 ]

##  doc/../gap/loewy.gi (1505-1518)
gap> data:= LoewyStructureInfoGAP( 23, 585 );;
gap> soc:= SingerAlg.BasesOfSocleSeries( data );;
gap> rad:= SingerAlg.BasesOfRadicalSeries( data );;
gap> I1:= SingerAlg.BasisOfPC( data, soc[3], rad[3] );;
gap> Length( I1 );
581
gap> data:= LoewyStructureInfoGAP( 212, 585 );;
gap> soc:= SingerAlg.BasesOfSocleSeries( data );;
gap> rad:= SingerAlg.BasesOfRadicalSeries( data );;
gap> I2:= SingerAlg.BasisOfPC( data, soc[3], rad[3] );;
gap> Length( I2 );
545

##  doc/../gap/permiso.g (455-497)
gap> # Loewy length 3, naturally isomorphic
gap> t1:= SingerAlg.MultTable( LoewyStructureInfo( 3, 7 ) );;
gap> t2:= SingerAlg.MultTable( LoewyStructureInfo( 6, 7 ) );;
gap> SingerAlg.IsInducedAlgebraIsomorphism( t1, t2, () );
true
gap> # q1 and q2 generate the same group of residues modulo z,
gap> # naturally isomorphic
gap> t1:= SingerAlg.MultTable( LoewyStructureInfo( 2, 7 ) );;
gap> t2:= SingerAlg.MultTable( LoewyStructureInfo( 4, 7 ) );;
gap> SingerAlg.IsInducedAlgebraIsomorphism( t1, t2, () );
true
gap> # one of the explicitly computed natural isomorphisms
gap> t1:= SingerAlg.MultTable( LoewyStructureInfo( 3, 65 ) );;
gap> t2:= SingerAlg.MultTable( LoewyStructureInfo( 9, 65 ) );;
gap> SingerAlg.IsInducedAlgebraIsomorphism( t1, t2, () );
true
gap> # one of the explicitly computed permutation isomorphisms
gap> # that are not natural isomorphisms
gap> t1:= SingerAlg.MultTable( LoewyStructureInfo(  41, 275 ) );;
gap> t2:= SingerAlg.MultTable( LoewyStructureInfo( 116, 275 ) );;
gap> SingerAlg.IsInducedAlgebraIsomorphism( t1, t2, () );
false
gap> pi:= (2,24,23,22,21,20,19,18,17,16,15,14,13,12,11,10,9,8,7,6,5,4,3)
> (28,29,30,31,32)(38,39,40,41,42)(43,44,45,46,47,48,49,50)
> (54,55,57,79,77,94,91,89,87,83,82,81,80,78,76,75,74,73,72,64,65,63,62,
> 61,60)
> (85,99,97,93,90,88,86)(92,108,107,106,105,98,96,95)
> (109,110,112,113,115)
> (114,116,117,120,118,121,124,127,119,122,125,129,132,149,146,144,143,
> 142,141,140,154,151,147,163,161,160,157,159,156,153,150,158,155,152,
> 148,145,128,131,133,134,135,136,137,123,126,130)(162,168,167,165,164)
> (169,170,171,172,179,181,182,185)(178,180,184,187,189,191,192)
> (183,186,188,190,194,195,196,197,199,201,202,203,204,205,213,212,214,
> 215,216,217,223,222,220,198,200)(227,234,233,232,231,230,229,228)
> (235,239,238,237,236)(245,249,248,247,246)
> (253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,
> 270,271,272,273,274,275);;
gap> SingerAlg.IsInducedAlgebraIsomorphism( t1, t2, pi );
true
gap> SingerAlg.IsInducedAlgebraIsomorphism( t1, t2, pi^-1 );
false

##  doc/../gap/permiso.g (261-285)
gap> # a canonical isomorphism
gap> data1:= LoewyStructureInfo( 3, 7 );;
gap> data2:= LoewyStructureInfo( 6, 7 );;
gap> SingerAlg.ProposedPermutationIsomorphism( data1, data2 );
()
gap> # a proper permutation isomorphism
gap> data1:= LoewyStructureInfo(  41, 275 );;
gap> data2:= LoewyStructureInfo( 116, 275 );;
gap> pi:= SingerAlg.ProposedPermutationIsomorphism( data1, data2 );;
gap> t1:= SingerAlg.MultTable( data1 );;
gap> t2:= SingerAlg.MultTable( data2 );;
gap> SingerAlg.IsInducedAlgebraIsomorphism( t1, t2, pi );
true
gap> # the reduced variant
gap> pi:= SingerAlg.ProposedPermutationIsomorphism( data1, data2,
>                                                   "reduced" );;
gap> pi.iso;  # achieved by a suitable sorting of the bases
()
gap> # no permutation isomorphism
gap> data1:= LoewyStructureInfo(  11, 171 );;
gap> data2:= LoewyStructureInfo(  68, 171 );;
gap> SingerAlg.ProposedPermutationIsomorphism( data1, data2 );
"different distributions of products"

##  doc/../gap/invar.g (879-900)
gap> inv:= ConsiderInvariantsByParameters( 117, [ 29, 35 ] );
rec( comment := "total 12 invariants checked", 
  label := "Prod(Annihilator(Power(J^1,2,1)),Roots(0,2,1))", 
  lists := [ [ 29 ], [ 35 ] ], success := true )
gap> ConsiderInvariantsByParameters( 247, [ 37, 46 ] );
rec( comment := "total 4 invariants plus LL4QuoDerDim checked", 
  label := "LL4QuoDerDim", lists := [ [ 46 ], [ 37 ] ], 
  success := true )
gap> ConsiderInvariantsByParameters( 171, [ 11, 68 ] );
rec( comment := "no decision, checked 11 invariants", 
  labels := [ "J^3", "Power(J^1,2,1)", "Annihilator(Roots(0,2,1))", 
      "Sum(Power(J^1,2,1),J^3)", 
      "Sum(Power(J^1,2,1),Annihilator(Roots(0,2,1)))", "J^2", "S_2", 
      "Annihilator(Sum(Power(J^1,2,1),Annihilator(Roots(0,2,1))))", 
      "Roots(0,2,1)", "Annihilator(Power(J^1,2,1))", "J^1" ], 
  success := false )
gap> res:= ConsiderInvariantsByParameters( 171, [ 11, 68 ],
>              rec( SubquoDerMax:= 158 ) );;
gap> res.success;
true

##  doc/../gap/invar.g (1473-1499)
gap> SingerAlg.InfoFromInvariantString(
>        LoewyStructureInfoGAP( 29, 6, 117 ),
>        "Prod(Annihilator(Power(J^1,2,1)),Roots(0,2,1))" );
rec( basisIndices := [ 36, 64, 69, 73, 80, 93, 95, 100, 101, 118 ] )
gap> SingerAlg.InfoFromInvariantString(
>        LoewyStructureInfoGAP( 35, 6, 117 ),
>        "Prod(Annihilator(Power(J^1,2,1)),Roots(0,2,1))" );
rec( basisIndices := [ 37, 51, 60, 64, 73, 77, 86, 87, 91, 100, 109, 
      113, 118 ] )
gap> SingerAlg.InfoFromInvariantString(
>        LoewyStructureInfoGAP( 2, 3, 7 ),
>        "Derivations" );
rec( derivationsDim := 24 )
gap> SingerAlg.InfoFromInvariantString(
>        LoewyStructureInfoGAP( 37, 12, 247 ),
>        "LL4QuoDerDim" );
rec( LL4QuoDerDim := 656 )
gap> SingerAlg.InfoFromInvariantString(
>        LoewyStructureInfoGAP( 68, 6, 171 ),
>        "SubquoDerDim(J^2,J^3)" );
rec( SubquoDerDim := 2025 )
gap> SingerAlg.InfoFromInvariantString(
>        LoewyStructureInfoGAP( 23, 12, 259 ),
>        "RC(J^3,J^1)" );
rec( solutionCount := [ 492, 51055 ] )

##  doc/../gap/invar.g (182-191)
gap> data:= LoewyStructureInfoGAP( 23, 12, 259 );;
gap> radser:= SingerAlg.BasesOfRadicalSeries( data );;
gap> SingerAlg.NumberOfProductsInSubspace( data, radser[3], radser[1] );
[ 492, 51055 ]
gap> data:= LoewyStructureInfoGAP( 60, 12, 259 );;
gap> radser:= SingerAlg.BasesOfRadicalSeries( data );;
gap> SingerAlg.NumberOfProductsInSubspace( data, radser[3], radser[1] );
[ 493, 161051 ]

##  doc/../gap/invar.g (520-527)
gap> data:= LoewyStructureInfoGAP( 37, 247 );;
gap> SingerAlg.LL4QuoDerDim( data );
656
gap> data:= LoewyStructureInfoGAP( 46, 247 );;
gap> SingerAlg.LL4QuoDerDim( data );
585

##  doc/../gap/invar.g (608-619)
gap> z:= 171;;  qs:= [ 11, 68 ];;
gap> datalist:= List( qs, q -> LoewyStructureInfoGAP( q, z ) );;
gap> ids:= [ Difference( [ 2 .. z+1 ], [ 10, 37, 55, 64, 82, 100 ] ),
>            [ 73, 91, 109, 118, 136, 163, 172 ] ];;
gap> ideals:= [ [ ids[1], ids[1] ], [ ids[2], ids[2] ] ];;
gap> labels:= [ "I", "J" ];;
gap> SingerAlg.SubquoDerDim( datalist, labels, ideals, 150 );
fail
gap> SingerAlg.SubquoDerDim( datalist, labels, ideals, 158 );
rec( derdim := [ 14179, 14201 ], labels := [ "I", "J" ] )

##  doc/../gap/loewy.gd (462-470)
gap> OrderModExt( 2, 7 );
3
gap> OrderModExt( 3, 7 );  # 3 is a primitive root modulo 7
6
gap> m:= (5^166-1) / 167;;      # about 10^113
gap> OrderModExt( 5, m, 166 );  # needs minutes without third argument
166

##  doc/../gap/access.g (128-132)
gap> val:= SingerAlg.ContentsOfDataFile( "mqe.json" );;
gap> val[1][2];
"This file contains the sorted list of values '[ e, q, m(q,e) ]', "

##  doc/../gap/invar.g (39-46)
gap> l:= [];;
gap> for i in GrayCodeSwitchIndexIterator( 4 ) do
>      Add( l, i );
>    od;
gap> l;
[ 1, 2, 1, 3, 1, 2, 1, 4, 1, 2, 1, 3, 1, 2, 1 ]

##  doc/../gap/invar.g (52-61)
gap> F:= GF(2);;  one:= One( F );;  V:= F^4;;
gap> v:= ShallowCopy( Zero( V ) );;  l:= [ ShallowCopy( v ) ];;
gap> for i in GrayCodeSwitchIndexIterator( 4 ) do
>      v[i]:= v[i] + one;
>      Add( l, ShallowCopy( v ) );
>    od;
gap> Set( l ) = Elements( V );
true

##  doc/../gap/invar.g (418-425)
gap> q:= 3;;  z:= 40;;  a:= SingerAlgebra( q, z, GF(2) );;
gap> T:= SingerAlg.MultTable( LoewyStructureInfo( 3, 40 ) );;
gap> SingerAlg.RightDerivationsDimension( T );
118
gap> Dimension( Derivations( CanonicalBasis( a ) ) );
118

##  doc/../gap/access.g (376-389)
gap> OneSingerAlgebraInfo( "z", 8 );                                  
rec( LL := 5, d := [  ], dec := 0, diff := 0, e := 1, 
  isom := [ 8, 3 ], m := 1, n := 2, q := 3, 
  vprime := [ 1, 2, 3, 2, 1 ], z := 8 )
gap> AllSingerAlgebraInfos( "diff", 1, "e", IsPrimeInt );        
[ rec( LL := 3, d := fail, dec := 1, diff := 1, 
      e := 380808546861411923, isom := [ 862, 3 ], m := 26, n := 43, 
      q := 3, vprime := [ 1, 861, 1 ], z := 862 ) ]
gap> OneSingerAlgebraInfo( "z", 8, r -> r.m, 2 );
rec( LL := 5, d := [  ], dec := 0, diff := 0, e := 3, 
  isom := [ 8, 5 ], m := 2, n := 2, q := 5, 
  vprime := [ 1, [ 3, 2 ], [ 1, 2 ] ], z := 8 )

##  doc/../gap/display.g (125-153)
gap> DisplaySingerAlgebras( "z", 7 );
    z |     q |    n |    LL | m(q,e) | diff |  isom
------+-------+------+-------+--------+------+------
    7 |     2 |    3 |     4 |      1 |    0 |     2
    7 |     3 |    6 |     3 |      6 |    0 |     3
    7 |     6 |    2 |     3 |      5 |    0 |     3
    7 |     8 |    1 |     8 |      1 |    0 |     8

gap> DisplaySingerAlgebras( "z", [ 1 .. 200 ], "diff", IsPosInt );
    z |     q |    n |    LL | m(q,e) | diff |  isom
------+-------+------+-------+--------+------+------
   70 |     3 |   12 |     3 |      8 |    1 |     3
   91 |     5 |   12 |     3 |     16 |    1 |     5
   95 |     8 |   12 |     3 |     28 |    1 |     2
  104 |     7 |   12 |     3 |     24 |    1 |     7
  123 |     2 |   20 |     3 |      6 |    1 |     2
  143 |    32 |   12 |     3 |    124 |    1 |     2
  148 |    23 |   12 |     3 |     88 |    1 |     3
  155 |    37 |   12 |     3 |    144 |    1 |     3
  182 |     5 |   12 |     3 |     16 |    1 |     5
  182 |    41 |   12 |     3 |    160 |    1 |     5
  182 |    45 |   12 |     3 |    176 |    1 |     5
  185 |    14 |   12 |     3 |     52 |    1 |     2
  185 |    27 |   12 |     3 |    104 |    1 |     2
  190 |    27 |   12 |     3 |    104 |    1 |     3
  195 |     7 |   12 |     4 |     18 |    1 |     7


##  doc/../gap/access.g (433-440)
gap> List( [ 2 .. 8 ], q -> IdSingerAlgebra( q, 7 ) );
[ [ 7, 2 ], [ 7, 3 ], [ 7, 2 ], [ 7, 3 ], [ 7, 3 ], fail, [ 7, 8 ] ]
gap> IdSingerAlgebra( 100, 259 );
fail
gap> IdSingerAlgebra( SingerAlgebra( 10, 11 ) );
[ 11, 2 ]

##  doc/database.xml (70-84)
gap> maxz:= 10000;;
gap> KnownDistribution:= [];;
gap> vectors:= "dummy";;
gap> for z in [ 1 .. maxz ] do
>      allforz:= AllSingerAlgebraInfos( "z", z );
>      vectors:= Set( allforz, r -> MakeImmutable( r.vprime ) );
>      positions:= List( allforz, r -> Position( vectors, r.vprime ) );
>      KnownDistribution[z]:= List( vectors, x -> [] );
>      for i in [ 1 .. Length( positions ) ] do
>        Add( KnownDistribution[z][ positions[i] ],
>             [ allforz[i].q ] );
>      od;
>    od;

##  doc/database.xml (89-112)
gap> ShowDistributionStatus:= function()
>    Print( "#I  min. no. of isom. types: ",
>           Sum( KnownDistribution, Length ), "\n",
>           "#I  max. no. of isom. types: ",
>           Sum( List( KnownDistribution,
>                      l -> Sum( l, Length ) ) ), "\n",
>           "#I  no. of nontriv. classes: ",
>           Sum( KnownDistribution,
>                l -> Number( l, x -> Length( x ) > 1 ) ), "\n",
>           "#I  no. of entries in these classes: ",
>           Length( Flat( Filtered( Concatenation( KnownDistribution ),
>                         x -> Length( x ) > 1 ) ) ), "\n",
>           "#I  no. of dimensions with open questions: ",
>           Number( KnownDistribution,
>                   l -> Maximum( List( l, Length ) ) > 1 ), "\n" );
>    end;;
gap> ShowDistributionStatus();
#I  min. no. of isom. types: 475581
#I  max. no. of isom. types: 768512
#I  no. of nontriv. classes: 47834
#I  no. of entries in these classes: 340765
#I  no. of dimensions with open questions: 9963

##  doc/database.xml (134-151)
gap> for z in [ 1 .. maxz ] do
>      for i in [ 1 .. Length( KnownDistribution[z] ) ] do
>        C:= KnownDistribution[z][i];
>        vector:= OneSingerAlgebraInfo( "z", z, "q", C[1][1] ).vprime;
>        if Length( vector ) = 1 or
>           ( Length( vector ) = 3 and IsInt( vector[2] ) ) then
>          KnownDistribution[z][i]:= [ Concatenation( C ) ];
>        fi;
>      od;
>    od;
gap> ShowDistributionStatus();
#I  min. no. of isom. types: 475581
#I  max. no. of isom. types: 557645
#I  no. of nontriv. classes: 31852
#I  no. of entries in these classes: 113916
#I  no. of dimensions with open questions: 5714

##  doc/database.xml (194-222)
gap> joins:= SingerAlg.ContentsOfDataFile( "joinsCan.json" )[2];;
gap> L:= "dummy";;
gap> for ll in joins do
>      # a pair of the form [ z, [ [ q1, q2, ... ], [ ... ], ... ] ]
>      z:= ll[1];
>      for i in [ 1 .. Length( KnownDistribution[z] ) ] do
>        L:= KnownDistribution[z][i];
>        for j in [ 1 .. Length( L ) ] do
>          for k in [ 1 .. j-1 ] do
>            if IsBound( L[k] ) and IsBound( L[j] ) and
>               ForAny( ll[2],
>                       l -> IsSubset( l, Set( [ L[j][1], L[k][1] ] ) ) ) then
>              # join the two classes
>              Append( L[k], L[j] );
>              Unbind( L[j] );
>            fi;
>          od;
>        od;
>        KnownDistribution[z][i]:= SortedList( Compacted( L ) );
>      od;
>    od;
gap> ShowDistributionStatus();
#I  min. no. of isom. types: 475581
#I  max. no. of isom. types: 484234
#I  no. of nontriv. classes: 7042
#I  no. of entries in these classes: 19924
#I  no. of dimensions with open questions: 2195

##  doc/database.xml (283-315)
gap> joins:= SingerAlg.ContentsOfDataFile( "joinsPerm.json" )[2];;
gap> applyjoin:= function( z, q1, q2 )
>      local i, L, j, k;
>      for i in [ 1 .. Length( KnownDistribution[z] ) ] do
>        L:= KnownDistribution[z][i];
>        for j in [ 1 .. Length( L ) ] do
>          for k in [ 1 .. j-1 ] do
>            if IsSubset( Set( [ q1, q2 ] ),
>                         Set( [ L[j][1], L[k][1] ] ) ) then
>              # join the two equivalence classes
>              Append( L[k], L[j] );
>              Unbind( L[j] );
>              KnownDistribution[z][i]:= SortedList( Compacted( L ) );
>              return;
>            fi;
>          od;
>        od;
>      od;
>      # This triple was not used at all.
>      Print( "#E  unnecessary join: ", [ z, q1, q2 ], "\n" );
>    end;;
gap> for l in joins do
>      # 'l' is a triple of the form [ z, q1, q2 ]
>      CallFuncList( applyjoin, l );
>    od;
gap> ShowDistributionStatus();
#I  min. no. of isom. types: 475581
#I  max. no. of isom. types: 481744
#I  no. of nontriv. classes: 5174
#I  no. of entries in these classes: 15608
#I  no. of dimensions with open questions: 1754

##  doc/database.xml (367-396)
gap> splits:= SingerAlg.ContentsOfDataFile( "splitsComb.json" )[2];;
gap> applysplit:= function( z, entry, entries, why )
>      local pos, len, elen, i;
>      pos:= Position( KnownDistribution[z], entry );
>      if pos = fail then
>        Print( "#E  did not find <entry> = ", entry,
>               " in KnownDistribution[", z, "]\n" );
>      elif Set( entry ) <> Union( entries ) then
>        Print( "#E  <entry> = ", entry,
>               " does not correspond to <entries> = ", entries, "\n" );
>      else
>        len:= Length( KnownDistribution[z] );
>        elen:= Length( entries ) - 1;
>        for i in [ len, len-1 .. pos+1 ] do
>          KnownDistribution[z][ i+elen ]:= KnownDistribution[z][i];
>        od;
>        KnownDistribution[z]{ [ pos .. pos + elen ] }:= entries;
>      fi;
>    end;;
gap> for l in splits do
>      CallFuncList( applysplit, l );
>    od;
gap> ShowDistributionStatus();
#I  min. no. of isom. types: 479512
#I  max. no. of isom. types: 481744
#I  no. of nontriv. classes: 1934
#I  no. of entries in these classes: 5422
#I  no. of dimensions with open questions: 791

##  doc/database.xml (424-433)
gap> splits[1];
[ 40, [ [ 3 ], [ 19 ] ], [ [ [ 3 ] ], [ [ 19 ] ] ], "Roots(0,2,1)" ]
gap> b:= CanonicalBasis( SingerAlgebra( 3, 40, GF(2) ) );;
gap> Dimension( Derivations( b ) );
118
gap> b:= CanonicalBasis( SingerAlgebra( 19, 40, GF(2) ) );;
gap> Dimension( Derivations( b ) );
112

##  doc/database.xml (466-477)
gap> splits:= SingerAlg.ContentsOfDataFile( "splitsOther.json" )[2];;
gap> for l in splits do
>      CallFuncList( applysplit, l );
>    od;
gap> ShowDistributionStatus();
#I  min. no. of isom. types: 481069
#I  max. no. of isom. types: 481744
#I  no. of nontriv. classes: 649
#I  no. of entries in these classes: 1495
#I  no. of dimensions with open questions: 350

##  doc/database.xml (488-500)
gap> str:= Concatenation( "[",
>              SingerAlg.ComputedOpenCases(), "]" );;
gap> if EvalString( str ) <>
>       SingerAlg.ContentsOfDataFile( "opencases.json" )[2] then
>      Print( "#E  'data/opencases.json' is not up to date." );
>    fi;
gap> str:= Concatenation( "[",
>              SingerAlg.ComputedIdInfoForSingerAlgebras(), "]" );;
gap> if EvalString( str ) <> SingerAlg.IdData[2] then
>      Print( "#E  The stored isomorphism type data are not up to date." );
>    fi;

##  doc/database.xml (532-570)
gap> candidates:= [];;
gap> for z in [ 1 .. 10000 ] do
>      # Fetch the data for this z and sort them by decreasing n.
>      cand:= AllSingerAlgebraInfos( "z", z );
>      SortParallel( List( cand, x -> - x.n ), cand );
>      qs:= List( cand, x -> x.q );
>      # Run over those candidates for which we know
>      # that the Loewy vector determines the isomorphism type.
>      for r in Filtered( cand, r -> Length( r.vprime ) <> 3 ) do
>        q:= r.q;
>        n:= r.n;
>        result:= [ q ];
>        # Find parameters [ Q, m, z ] such that m divides n
>        # and Q is the minimal representative of the subgroup of prime
>        # residues modulo z that is generated by q^(n/m),
>        # and such that the Loewy vector is the same as for r.
>        for d in Difference( DivisorsInt( r.n ), [ 1 ] ) do
>          m:= n/d;
>          Q:= PowerModInt( q, d, z );
>          Q:= Minimum( List( PrimeResidues( m ), 
>                             e -> PowerModInt( Q, e, z ) ) );
>          if Q = 1 then
>            Q:= z+1;
>          fi;
>          R:= cand[ Position( qs, Q ) ];
>          if r.vprime = R.vprime then
>            # The Loewy vectors for q and Q are equal.
>            AddSet( result, Q );
>          fi;
>        od;
>        if Length( result ) > 1 then
>          Add( candidates, [ z, result ] );
>        fi;
>      od;
>    od;
gap> Length( candidates );
22518

##  doc/database.xml (577-586)
gap> joins:= SingerAlg.ContentsOfDataFile( "joinsCan.json" )[2];;
gap> for entry in candidates do
>      z:= entry[1];
>      joinsz:= First( joins, l -> l[1] = z );
>      if not ForAny( joinsz[2], l -> IsSubset( l, entry[2] ) ) then
>        Error( "did not find ", entry, " among the known canon. isom." );
>      fi;
>    od;

##
gap> STOP_TEST( "docxpl2.tst" );
gap> SizeScreen( save );;

#############################################################################
##
#E
